var wLarge;
var canvasLayer;
var canvasContext;

var pen_color ="black";     //default pen colour
var pen_size = 2;
var bg_color ="white";   //default background colour

var board_color_mode =1;    // 1: white BG & black pen  , 2: black BG & white pen , 3: blue BG & white pen .
var pen_mode =1;    // use ->  1: main pen colour , 2: BackGround colour
var COLOR_PEN_MODE_TYPE =2; // 1: main pen , 2: BackGround

var status_mousedown_left = false;
var status_mousedown_right = false;
var status_mousedown_middle = false;

var status_first_pendown =true;
var last_pen_x =0;
var last_pen_y =0;

var slideMenu="close";

var menu_data =
[
    [{
        text: "交换颜色",
        func: function() 
        {
            change_pen_status();

            clear_status();
        }
    },
    {
        text: "新画板",
        data:
        [
            [{
                text: "黑底白字白底黑字",
                func: function() 
                {
                    board_color_mode =1;
                    pen_mode =1;
                    pen_color ="black";
                    pen_size = 2;
                    bg_color ="white";
                    drawBorderAndX();
                    clear_status();
                }
            },
            {
                text: "黑底白字",
                func: function() 
                {
                    board_color_mode =2;
                    pen_mode =1;
                    pen_color ="white";
                    pen_size = 2;
                    bg_color ="black";
                    drawBorderAndX();
                    clear_status();
                }
            },
            {
                text: "蓝底白字",
                func: function() 
                {
                    board_color_mode =3;
                    pen_mode =1;
                    pen_color ="white";
                    pen_size = 2;
                    bg_color ="darkblue";
                    drawBorderAndX();
                    clear_status();
                }
            }]
        ]
    },
    {
        text: "保存为png图稿",
        func: function() 
        {
            save_png_image();

            clear_status();
        }
    }],
    [{
        text: "退出菜单",
        func: function() 
        {
            clear_status();
        }
    }]
];


function aboutDrawBoard()
{
    alert("        感谢您的使用 drawboard概念画板 v1.0.1,  使用是对作者最大的尊重,谢谢!  如有反馈意见或建议请您联系责任作者:mr_wood@126.com .");
}


function exchangeColor()
{
    change_pen_status();

    clear_status();
    
    closeSlideMenu();
}


function newDrawingBlackWhite()
{
    board_color_mode =1;
    pen_mode =1;
    pen_color ="black";
    pen_size = 2;
    bg_color ="white";
    drawBorderAndX();
    clear_status();
    
    closeSlideMenu();
}


function newDrawingWhiteBlack()
{
    board_color_mode =2;
    pen_mode =1;
    pen_color ="white";
    pen_size = 2;
    bg_color ="black";
    drawBorderAndX();
    clear_status();
                        
    closeSlideMenu();
}


function newDrawingBlueWhite()
{
    board_color_mode =3;
    pen_mode =1;
    pen_color ="white";
    pen_size = 2;
    bg_color ="darkblue";
    drawBorderAndX();
    clear_status();
                        
    closeSlideMenu();
}


function savePng()
{
    save_png_image();

    clear_status();
    
    closeSlideMenu();
}


function quitAPP()
{
    if( confirm( '确认退出？' ) )
    {
        plus.runtime.quit();
    }
}


mui.back =function()
{
    if( slideMenu == "close" )
            {
                slideMenu="shown";
                mui('.mui-off-canvas-wrap').offCanvas().show();              
            }else
                {//then is "shown" case
                    closeSlideMenu();
                }
}


/*
mui.back =function()
{
    if( slideMenu == "close" )
    {
        if( confirm( '确认退出？' ) )
        {
            plus.runtime.quit();
        }
        
    }else
        {//then is "shown" case
            closeSlideMenu();
        }
    
}
*/


function closeSlideMenu()
{
    slideMenu ="close";
    mui('.mui-off-canvas-wrap').offCanvas().close();
}


mui.plusReady(function() 
{
    plus.screen.lockOrientation("portrait-primary");    //force set phone use position style
    
    
    drawBorderAndX();
    window.onresize = drawBorderAndX;
    
    canvasLayer.addEventListener( "mousedown", mouse_down, false );
    canvasLayer.addEventListener( "mouseup", mouse_up, false );
    /*
    plus.key.addEventListener("backbutton",function(){
        alert( "BackButton Key pressed!" );
    });
    */
   
    //mui.init();
    /*
    plus.key.addEventListener( 'backbutton', function()
    { // add MainButton quit action

        if( confirm( '确认退出？' ) )
        {
            plus.runtime.quit();
        }

    }, false );
    */
});

    
    
    function getwLarge()
    {
        return {'width': window['innerWidth'] || document.documentElement.clientWidth,
            'height': window['innerHeight'] || document.documentElement.clientHeight}
    }

    function drawBorderAndX()
    {
        var tWidth,tHeight;

        wLarge =getwLarge();
        canvasLayer = document.getElementById("canvasMain");
        canvasContext = canvasLayer.getContext("2d");

        tWidth =wLarge["width"];
        tHeight =wLarge["height"];

        canvasLayer.width =0;
        canvasLayer.height =0;
        canvasLayer.width =tWidth;
        canvasLayer.height =tHeight-0;    // -4 is adjustment of disable canvas scorllbar appearation

        canvasContext.beginPath();

        canvasContext.fillStyle =bg_color;
        canvasContext.fillRect(0,0,tWidth,tHeight);

        //document.body.style.backgroundColor =bg_color;
        //mui("html").backgroundColor =bg_color;

        //bgpixel =canvasContext.getImageData(1,1,1,1);
        //bgcolor = "rgba(" + bgpixel.data[0] + "," + bgpixel.data[1] + "," + bgpixel.data[2] + "," + bgpixel.data[3] + ")";
        
// wood_add_code start   11th,august,2016,wood
        $(document.body).toggleClass("html-body-overflow");
        
        canvasLayer.addEventListener("touchstart", touchStart, false);
        canvasLayer.addEventListener("touchmove", touchMove, false);
        canvasLayer.addEventListener("touchend", touchEnd, false);
        
        
// wood_add_code end

    }

    function getMousePoint(ev)
    {
        var x=0;
        var y=0;

        if(!ev) ev=window.event;
        if (typeof window.pageYoffset!= "undefined")
        {//pageYoffset是Netscape特有
            x = window.pageXOffset;
            y = window.pageYOffset;
        }else if (typeof document.compatMode != "undefined" && document.compatMode != "BackCompat")
            {//检测标准模式
                x = document.documentElement.scrollLeft;
                y = document.documentElement.scrollTop;
            }else if (typeof document.body != "undefined")
                {
                    x = document.body.scrollLeft - document.body.clientLeft;
                    y = document.body.scrollTop - document.body.clientTop;
                }
        x += ev.clientX;
        y += ev.clientY;
        return {'x' : x, 'y' : y};
    }



///////////////////////
/////////////
////////////////////////
/*
drawBorderAndX();
window.onresize = drawBorderAndX;

canvasLayer.addEventListener( "mousedown", mouse_down, false );
canvasLayer.addEventListener( "mouseup", mouse_up, false );
*/

        
/*
mui.plusReady(function()
{
    //仅支持竖屏显示
    plus.screen.lockOrientation("portrait-primary");
    main = plus.webview.currentWebview();

    //处理侧滑导航，为了避免和子页面初始化等竞争资源，延迟加载侧滑页面；
    setTimeout(function() {
        menu = mui.preload({
            id: 'index-menu',
            url: 'index-menu.html',
            styles: {
                left: 0,
                width: '70%',
                zindex: -1
            },
            show: {
                aniShow: 'none'
            }
        });
    }, 200);
});
      */
     
function clear_status()
{
    status_first_pendown = true;
    status_mousedown_left = false;
    status_mousedown_right = false;
    status_mousedown_middle = false;
}

function mouse_down( ev )
{
    if( ev.button == 2 )
    { //right button
        status_mousedown_right = true;
        $( document ).smartMenu( menu_data,
        {
            name: "testmenu",
            textLimit: 30
        } );
    }
    else if( ev.button == 0 )
    { //left button
        status_mousedown_left = true;
    }
    else if( ev.button == 1 )
    { //middle button  
        status_mousedown_middle = true;

        change_pen_status();

        clear_status();
    }
    else
    { //other button
        //do-nothing
    }

}

function mouse_up( ev )
{
    clear_status();
}

function change_pen_status()
{
    if( board_color_mode == 1 )
    { //1: black BG & white pen
        if( pen_mode < COLOR_PEN_MODE_TYPE )
        {
            ++pen_mode;
        }
        else
        {
            pen_mode = 1;
        }

        switch( pen_mode )
        {
            case 1:
                pen_color = "black";
                pen_size = 2;
                break;

            case 2:
                pen_color = "white";
                pen_size = 15;
                break;

            default:
                pen_color = "black";
                pen_size = 2;

        };
    }
    else if( board_color_mode == 2 )
    { //2: white BG & black pen
        if( pen_mode < COLOR_PEN_MODE_TYPE )
        {
            ++pen_mode;
        }
        else
        {
            pen_mode = 1;
        }

        switch( pen_mode )
        {
            case 1:
                pen_color = "white";
                pen_size = 2;
                break;

            case 2:
                pen_color = "black";
                pen_size = 15;
                break;

            default:
                pen_color = "white";
                pen_size = 2;

        };
    }
    else if( board_color_mode == 3 )
    { //3: blue BG & white pen
        if( pen_mode < COLOR_PEN_MODE_TYPE )
        {
            ++pen_mode;
        }
        else
        {
            pen_mode = 1;
        }

        switch( pen_mode )
        {
            case 1:
                pen_color = "white";
                pen_size = 2;
                break;

            case 2:
                pen_color = "darkblue";
                pen_size = 15;
                break;

            default:
                pen_color = "white";
                pen_size = 2;

        };
    }

    // clear status
    clear_status();

}

$( document ).mousemove( function( e )
{e.preventDefault();
    if( status_mousedown_left )
    {
        canvasContext.fillStyle = bg_color;

        var pos = getMousePoint( e );
        var x;
        var y;

        x = pos[ 'x' ];
        y = pos[ 'y' ];

        //	draw current cursor position
        canvasContext.fillStyle = "black";
        canvasContext.textAlign = 'center';
        canvasContext.font = '30px Arial';

        //====================================================
        if( status_first_pendown )
        {
            status_first_pendown = false;
            last_pen_x = x;
            last_pen_y = y;

        }
        else
        {

        }

        canvasContext.lineWidth = pen_size;
        canvasContext.beginPath();
        canvasContext.moveTo( last_pen_x, last_pen_y );
        canvasContext.lineTo( x, y );
        canvasContext.lineCap = "round";
        canvasContext.lineJoin = "round";
        canvasContext.strokeStyle = pen_color;
        canvasContext.stroke();

        last_pen_x = x;
        last_pen_y = y;

    }
    else
    {
        // do nothing
    }

} );


Date.prototype.format = function (format) 
{//download function form internet
    var o = {  
        "M+": this.getMonth() + 1,  //month   
        "d+": this.getDate(),     //day   
        "h+": this.getHours(),    //hour   
        "m+": this.getMinutes(),  //minute   
        "s+": this.getSeconds(), //second   
        "q+": Math.floor((this.getMonth() + 3) / 3),  //quarter   
        "S": this.getMilliseconds() //millisecond   
    }  
    var week=["星期日","星期一","星期二","星期三","星期四","星期五","星期六"];  
    if (/(y+)/.test(format)) {  
        format = format.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));  
    }  
    if (/(w+)/.test(format)){  
        format = format.replace(RegExp.$1, week[this.getDay()]);  
    }  
    for (var k in o) {  
        if (new RegExp("(" + k + ")").test(format)) {  
            format = format.replace(RegExp.$1, RegExp.$1.length == 1 ? o[k] : ("00" + o[k]).substr(("" + o[k]).length));  
        }  
    }  
    return format;  
}


function getyyyyMMdd()
{
    var d = new Date();
    var curr_date = d.getDate();
    var curr_month = d.getMonth() + 1; 
    var curr_year = d.getFullYear();
    String(curr_month).length < 2 ? (curr_month = "0" + curr_month): curr_month;
    String(curr_date).length < 2 ? (curr_date = "0" + curr_date): curr_date;
    var yyyyMMdd = curr_year + "" + curr_month +""+ curr_date;
    return yyyyMMdd;
}    

function save_png_image()
{
    //start download the image into the phone

    //1.get data_url
    var canvasPNG_URL =canvasLayer.toDataURL();
    var bitmapObj=new plus.nativeObj.Bitmap();

    var basePath =new Array("mnt/sdcard/","mnt/sdcard2/","_documents/","_downloads/");
    var subDirName =getyyyyMMdd();
    var offsetPath ="drawboard/"+subDirName+"/";
    
    var timestamp = new Date();
    var finename =timestamp.format('yyyyMMdd_h_m_S') + ".png";   //simple file name
    
    var offsetPathFileName =offsetPath + finename;

    var rtnCreateBitmapObject =true;

    
    bitmapObj.loadBase64Data(canvasPNG_URL,function()
    {
        rtnCreateBitmapObject =true;
    },function()
        {
            rtnCreateBitmapObject =false;
        });
    
    if( rtnCreateBitmapObject )
    {
    //case basePath[0]
        bitmapObj.save(basePath[0] + offsetPathFileName ,{overwrite:true},function(){
        //alert("saved");
        plus.nativeUI.toast("已成功保存在     "+ offsetPathFileName,{duration:"long"});
        window.saveStatus =true;
        console.log( basePath[0] + "保存成功");
        
        },function(){
            console.log( basePath[0] +"保存失败");
            }
        );
        
    //case basePath[1]
        bitmapObj.save(basePath[1] + offsetPathFileName ,{overwrite:true},function(){
        //alert("saved");
        plus.nativeUI.toast("已成功保存在     "+ offsetPathFileName,{duration:"long"});
        window.saveStatus =true;
        console.log( basePath[1] + "保存成功");
        
        },function(){
            console.log( basePath[1] +"保存失败");
            }
        );
        
    //case basePath[2]
        bitmapObj.save(basePath[2] + offsetPathFileName ,{overwrite:true},function(){
        //alert("saved");
        plus.nativeUI.toast("已成功保存在     "+ offsetPathFileName,{duration:"long"});
        window.saveStatus =true;
        console.log( basePath[2] + "保存成功");
        
        },function(){
            console.log( basePath[2] +"保存失败");
            }
        );
          
    //case basePath[3]
        bitmapObj.save(basePath[3] + offsetPathFileName ,{overwrite:true},function(){
        //alert("saved");
        plus.nativeUI.toast("已成功保存在     "+ offsetPathFileName,{duration:"long"});
        window.saveStatus =true;
        console.log( basePath[3] + "保存成功");
        
        },function(){
            console.log( basePath[3] +"保存失败");
            }
        );
        
    }else
        {
            plus.nativeUI.toast("保存操作失败",{duration:"long"});
        }
    
    
        
    bitmapObj.clear();

/*
    plus.gallery.save( '_www/img1.png, function () {
            console.log( "保存图片到相册成功" );
        },function(){
            console.log( "保存图片到相册失败" );
        }
    );
    */
    
//console.log(atob(canvasPNG_URL));
    //2.convert data url to file
    //var blob = dataURItoBlob(canvasPNG_URL);
    //var fd = new FormData(document.forms[0]);
    //var xhr = new XMLHttpRequest();
    
 //   fd.append("myFile", blob);
 //   xhr.open('POST', '/', true);
 //   xhr.send(fd);
    
    
    
    //console.log(canvasPNG_URL);
    
    //var pngDownload =plus.downloader.createDownload( canvasPNG_URL );
    /*
    var pngDownload =plus.downloader.createDownload( canvasPNG_URL, {}, function ( d, status ) {
        // 下载完成
        if ( status == 200 ) 
        {
            console.log( "Download success: " + d.filename );
        } else 
            {
                 console.log( "Download failed: " + status ); 
            }
    });
    */
    //console.log(pngDownload);
    //pngDownload.start();
    //console.log(pngDownload.url);
    //console.log(pngDownload.state);
    
    //Canvas2Image.saveAsPNG( canvasLayer );

    /*
    var img_data_uri = canvasLayer.toDataURL();
    img_data_uri = img_data_uri.replace("image/png", "image/octet-stream");
    //window.open(img_data_uri);

    	      document.location.href = img_data_uri;
    */

}

// wood add code start 12th,august,2016,wood
function touchStart( ev )
{
    status_mousedown_left = true;

}

function touchEnd( ev )
{
    clear_status();
}

function touchMove( ev )
{
    if (ev.targetTouches.length == 1) 
    {//Single finger touched
        var touch = ev.touches[ 0 ];
        y = touch.pageY;
        x = touch.pageX;
    
    
        canvasContext.fillStyle = bg_color;
    
    
        //  draw current cursor position
        canvasContext.fillStyle = "black";
        canvasContext.textAlign = 'center';
        canvasContext.font = '30px Arial';
    
        //====================================================
        if( status_first_pendown )
        {
            status_first_pendown = false;
            last_pen_x = x;
            last_pen_y = y;
    
        }
        else
        {
    
        }
    
        canvasContext.lineWidth = pen_size;
        canvasContext.beginPath();
        canvasContext.moveTo( last_pen_x, last_pen_y );
        canvasContext.lineTo( x, y );
        canvasContext.lineCap = "round";
        canvasContext.lineJoin = "round";
        canvasContext.strokeStyle = pen_color;
        canvasContext.stroke();
    
        last_pen_x = x;
        last_pen_y = y;
    }else
        {//multi finger touched
            //alert("multi-finger touched");
            if( slideMenu == "close" )
            {
                slideMenu="shown";
                mui('.mui-off-canvas-wrap').offCanvas().show();              
            }else
                {//then is "shown" case
                    closeSlideMenu();
                }

            //TODO need add code
            
            /*
            status_mousedown_right = true;
            $( document ).smartMenu( menu_data,
            {
                name: "testmenu",
                textLimit: 30
            } );
            */
            
        }
    


}
// wood add code end